% Exercise Sheet 10: Fundamental Limits
clear all;

% =============================================
% Simulation of the Plant
% =============================================
% Plant 
s = tf('s');
G = 5*(s-1)/(s+1)/(s-5);

% =======================================
% Problem 21a
% =======================================
% pole placement design for closed-loop poles at s = -10
r = [1; 30; 300; 1000];
M = [1 0 0 0 ; -4 1 5 0; -5 -4 -5 5; 0 -5 0 -5];
v = inv(M)*r;
l1 = v(1);
l0 = v(2);
p1 = v(3);
p0 = v(4);
f0 = 1000/163.1;
C = (p1*s + p0)/(l1*s + l0);
T = simplify(1/(1 + 1/G/C))
% reference step
r = 1; 
d = 0;
options = simset('Solver','ode45');
sim('ECE441_Ex10_solution_simulink',[0,5],options);
figure(1);
plot(t,y);
legend('reference step $r = 1')
grid
xlabel('time [sec]')
ylabel('output')
% disturbance step
r = 0;
d = 1;
sim('ECE441_Ex10_solution_simulink',[0,5],options);
figure(2);
plot(t,y);
legend('disturbance step $d = 1')
grid
xlabel('time [sec]')
ylabel('output')

% =======================================
% Problem 21b
% =======================================
% pole placement design for closed-loop poles at s = -2
r = [1; 6; 12; 8];
M = [1 0 0 0 ; -4 1 5 0; -5 -4 -5 5; 0 -5 0 -5];
v = inv(M)*r;
l1 = v(1);
l0 = v(2);
p1 = v(3);
p0 = v(4);
f0 = -8/13.87;
C = (p1*s + p0)/(l1*s + l0);
T = simplify(1/(1 + 1/G/C))
% reference step
r = 1; 
d = 0;
options = simset('Solver','ode45');
sim('ECE441_Ex10_solution_simulink',[0,10],options);
figure(3);
plot(t,y);
legend('reference step $r = 1')
grid
xlabel('time [sec]')
ylabel('output')
% disturbance step
r = 0;
d = 1;
sim('ECE441_Ex10_solution_simulink',[0,10],options);
figure(4);
plot(t,y);
legend('disturbance step $d = 1')
grid
xlabel('time [sec]')
ylabel('output')

% =======================================
% Problem 21c
% =======================================
% pole placement design for closed-loop poles at s = -0.5
r = [1; 1.5; .75; .125];
M = [1 0 0 0 ; -4 1 5 0; -5 -4 -5 5; 0 -5 0 -5];
v = inv(M)*r;
l1 = v(1);
l0 = v(2);
p1 = v(3);
p0 = v(4);
f0 = -.125/6.984;
C = (p1*s + p0)/(l1*s + l0);
T = simplify(1/(1 + 1/G/C))
% reference step
r = 1; 
d = 0;
options = simset('Solver','ode45');
sim('ECE441_Ex10_solution_simulink',[0,30],options);
figure(5);
plot(t,y);
legend('reference step $r = 1')
grid
xlabel('time [sec]')
ylabel('output')
% disturbance step
r = 0;
d = 1;
sim('ECE441_Ex10_solution_simulink',[0,30],options);
figure(6);
plot(t,y);
legend('disturbance step $d = 1')
grid
xlabel('time [sec]')
ylabel('output')

% =======================================
% Problem 22
% =======================================
% Simulation without noise
n_amp = 0;
n_freq = 0;
options = simset('Solver','ode45');
sim('ECE441_Ex10_solution_simulink_P22',[0,10],options);
figure(7);
plot(t,y);
grid
xlabel('time [sec]')
ylabel('output')
figure(8);
plot(t,y);
grid
xlabel('time [sec]')
ylabel('output')
% fast noise
n_amp = .1;
n_freq = 100;
sim('ECE441_Ex10_solution_simulink_P22',[0,10],options);
figure(7);
hold on;
plot(t,y,'k--');
legend('without noise','noise 100 rad/sec')

% slow noise
n_freq = 10;
sim('ECE441_Ex10_solution_simulink_P22',[0,10],options);
figure(8);
hold on;
plot(t,y,'k--');
n_freq = 1;
sim('ECE441_Ex10_solution_simulink_P22',[0,10],options);
plot(t,y,'m:');
legend('without noise','noise 10 rad/sec','noise 1 rad/sec')

